///////////////////////////////////////////////////////////////////////////////
//
//  Vom Xbase++ FormDesigner generierter Klassen Code
//    Erstellt am: 10.11.08 Zeit: 00:12:34
//
//  Contents  :
//    Diese Datei enthlt das Gerst zur Implementierung der Nutzungsebene.
//    Daher kann und soll diese Datei verndert werden.
//
///////////////////////////////////////////////////////////////////////////////

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "Directry.ch"
#include "DLL.CH"
#include "NLS.CH"


#include "XCM.CH"


#define ITEM_SPACING        5
#define IMAGE_BOX           16

#define COLOR_BASE_PALI    GraMakeRGBColor({229,229,255}) // XBPSYSCLR_HILITEBACKGROUND
*#define COLOR_BASE_FUER    XBPSYSCLR_MENU   // GraMakeRGBColor({153,153,255})
#define COLOR_BASE_FUER    GRA_CLR_GREEN
#define COLOR_BASE_XFUER   GRA_CLR_PALEGRAY
*#define MENU_BGCOLOR       XBPSYSCLR_MENU
#define MENU_BGCOLOR       XBPSYSCLR_WINDOW
*GRA_CLR_PALEGRAY     //  COLOR_BASE_FUER


#Define XBPSPLITBAR_HORIZONTAL  0
#Define XBPSPLITBAR_VERTICAL    1

#Define XBPSPLITBAR_IMAGE_VERTICAL_RIGHT        1
#Define XBPSPLITBAR_IMAGE_VERTICAL_LEFT         2
#Define XBPSPLITBAR_IMAGE_VERTICAL_LEFT_RIGHT   3
#Define XBPSPLITBAR_IMAGE_HORIZONTAL_UP         4
#Define XBPSPLITBAR_IMAGE_HORIZONTAL_DOWN       5
#Define XBPSPLITBAR_IMAGE_HORIZONTAL_UP_DOWN    6

#PRAGMA LIBRARY( "ASCOM10.LIB" )
#PRAGMA LIBRARY( "XPPUI2.LIB" )

STATIC oLW0

PROCEDURE AppSys
// Desktop remains application window
RETURN

PROCEDURE Main
LOCAL nEvent, oXbp, mp1, mp2
LOCAL lExit := .F.
LOCAL oXCM
LOCAL lRefresh := .T.

   SET EPOCH TO YEAR( DATE() ) - 50
   SET DATE GERMAN                               // DD.MM.YY
   SETLOCALE( NLS_ICURRENCYEURO, "1" )
   SETLOCALE( NLS_SCURRENCY, CHR( 213 ) )

   oXCM := XCMForm():New()
   oXCM:close := {|| lExit := .T. }
   oXCM:Create()

   oXCM:oLW1 := XCMBrowse():New( oXCM:oStatLWl,1):create()
   oXCM:oLW2 := XCMBrowse():New( oXCM:oStatLWr,2):create()

   oXCM:show()

   oLW0 := 1
   SetAppFocus(oXCM:oLW1:browser)

   nEvent := xbe_None
   DO WHILE !lExit
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      DO CASE

         CASE nEvent == xbeP_Keyboard .AND. mp1 = xbeK_ALT_F4
            lExit := .T.

         CASE nEvent == xbeP_Keyboard .AND. mp1 = xbeK_TAB

            IF oLW0 = 1
               oLW0 := 2
               SetAppFocus(oXCM:oLW2:browser)
            ELSE
               oLW0 := 1
               SetAppFocus(oXCM:oLW1:browser)
            ENDIF

         CASE nEvent == xbeP_Keyboard .AND. oXbp:isDerivedFrom("XbpBrowse")
            lRefresh := .T.
            DO CASE
               CASE mp1 == xbeK_ALT_1 ; SortFiles( oXbp, F_NAME )
               CASE mp1 == xbeK_ALT_2 ; SortFiles( oXbp, F_SIZE )
               CASE mp1 == xbeK_ALT_3 ; SortFiles( oXbp, F_WRITE_DATE )
               CASE mp1 == xbeK_ALT_4 ; SortFiles( oXbp, F_WRITE_TIME )

               CASE mp1 == xbeK_ENTER ; ChangeDirectory( oXbp )

               CASE mp1 == xbeK_UP          ; oXbp:up()
               CASE mp1 == xbeK_DOWN        ; oXbp:down()
               CASE mp1 == xbeK_LEFT        ; oXbp:left()
               CASE mp1 == xbeK_RIGHT       ; oXbp:right()
               CASE mp1 == xbeK_HOME        ; oXbp:firstCol()
               CASE mp1 == xbeK_END         ; oXbp:lastCol()
               CASE mp1 == xbeK_PGUP        ; oXbp:pageUp()
               CASE mp1 == xbeK_PGDN        ; oXbp:pageDown()
               CASE mp1 == xbeK_CTRL_UP     ; oXbp:goTop()
               CASE mp1 == xbeK_CTRL_DOWN   ; oXbp:goBottom()
               CASE mp1 == xbeK_CTRL_LEFT   ; oXbp:panLeft()
               CASE mp1 == xbeK_CTRL_RIGHT  ; oXbp:panRight()
               CASE mp1 == xbeK_CTRL_HOME   ; oXbp:panHome()
               CASE mp1 == xbeK_CTRL_END    ; oXbp:panEnd()
               CASE mp1 == xbeK_CTRL_PGUP   ; oXbp:goTop()
               CASE mp1 == xbeK_CTRL_PGDN   ; oXbp:goBottom()

            OTHERWISE
               lRefresh := .F.
            ENDCASE
            IF lRefresh = .T.
               oXbp:refreshCurrent()
            ENDIF

         CASE nEvent == xbeP_Quit
            QUIT   // AppQuit()

         OTHERWISE
            oXbp:HandleEvent ( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

RETURN

CLASS XCMForm FROM XbpDialog
   EXPORTED:
      VAR editControls

      * Enthaltene Kontrollelemente
      VAR ToolBar1
      VAR oStatLWl
      VAR oStatLWr
      VAR oStatPB
      VAR oPB01
      VAR oPB02
      VAR oPB03
      VAR oPB04
      VAR oPB05
      VAR oPB06
      VAR oPB07
      VAR oPB08
      VAR oPB09
      VAR oPB10
      VAR oStatbar
*      VAR Static1
      VAR oCBLeft
      VAR oCBright
      VAR oActivDir
      VAR oPBHis
      VAR oRunShell

      VAR oLW1
      VAR oLW2

      VAR oSplit
      VAR oPanel

      METHOD init
      METHOD create

ENDCLASS

******************************************************************************
* Formular initialisieren
******************************************************************************
METHOD XCMForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {119,78}, ;
           aSize    TO {800,600}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )
   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "Xbase++ Control Manager"
   ::XbpDialog:icon  :=  1000
   ::XbpDialog:resize := { || _Resize( ::XbpDialog , ::oSplit, ::oStatLWl , ::oStatLWr , ::oLW1 , ::oLW2 ) }

   ::editControls := {}
   ::oLW1 := NIL
   ::oLW2 := NIL

   ::ToolBar1 := XbpToolBar():new( ::drawingArea, , {0,500}, {792,12} )
   ::ToolBar1:TabStop := .T.

   //
   // Create vertical splitbar object
   //
   ::oSplit := XbpSplitbar():new( ::drawingArea, , {408,92}, {  0,332} )
   ::oSplit:clipSiblings  := .T.
   ::oSplit:orientation   := XBPSPLITBAR_VERTICAL       // this is a vertical XbpSplitbar
   ::oSplit:SplitterMoved := { || _Resize( ::XbpDialog , ::oSplit, ::oStatLWl , ::oStatLWr , ::oLW1 , ::oLW2 ) }
   ::oSplit:LiveRedraw    := .F.                        // don't render while dragging
   ::oSplit:nImageType    := XBPSPLITBAR_IMAGE_VERTICAL_LEFT_RIGHT

   ::oStatLWl := XbpStatic():new( ::drawingArea, , {  4,92}, {380,376} )
   ::oStatLWl:caption := "Left"
   ::oStatLWl:clipSiblings := .T.
   ::oStatLWl:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER
   ::oStatLWl:ClipChildren := .T.
   ::oStatLWl:SetColorBG(GRA_CLR_RED)

   ::oStatLWr := XbpStatic():new( ::drawingArea, , {408,92}, {380,376} )
   ::oStatLWr:caption := "Right"
   ::oStatLWr:clipSiblings := .T.
   ::oStatLWr:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER
   ::oStatLWr:ClipChildren := .T.
   ::oStatLWr:SetColorBG(GRA_CLR_BLUE)

   ::oStatPB  := XbpStatic():new( ::drawingArea, , {0,26}, {792,46} )
   ::oStatPB:caption := ""
   ::oStatPB:clipSiblings := .T.
   ::oStatPB:type := XBPSTATIC_TYPE_GROUPBOX

   ::oPB01    := XbpPushButton():new( ::oStatPB, , {  4,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB01:caption := "F1"
   ::oPB01:tabStop := .T.
   ::oPB01:activate := {|| NIL }

   ::oPB02    := XbpPushButton():new( ::oStatPB, , { 82,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB02:caption := "F2"
   ::oPB02:tabStop := .T.
   ::oPB02:activate := {|| NIL }

   ::oPB03    := XbpPushButton():new( ::oStatPB, , {160,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB03:caption := "F3"
   ::oPB03:tabStop := .T.
   ::oPB03:activate := {|| NIL }

   ::oPB04    := XbpPushButton():new( ::oStatPB, , {238,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB04:caption := "F4"
   ::oPB04:tabStop := .T.
   ::oPB04:activate := {|| NIL }

   ::oPB05    := XbpPushButton():new( ::oStatPB, , {316,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB05:caption := "F5"
   ::oPB05:tabStop := .T.
   ::oPB05:activate := {|| NIL }

   ::oPB06    := XbpPushButton():new( ::oStatPB, , {396,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB06:caption := "F6"
   ::oPB06:tabStop := .T.
   ::oPB06:activate := {|| NIL }

   ::oPB07    := XbpPushButton():new( ::oStatPB, , {474,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB07:caption := "F7"
   ::oPB07:tabStop := .T.
   ::oPB07:activate := {|| NIL }

   ::oPB08    := XbpPushButton():new( ::oStatPB, , {552,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB08:caption := "F8"
   ::oPB08:tabStop := .T.
   ::oPB08:activate := {|| NIL }

   ::oPB09    := XbpPushButton():new( ::oStatPB, , {630,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB09:caption := "F9"
   ::oPB09:tabStop := .T.
   ::oPB09:activate := {|| NIL }

   ::oPB10    := XbpPushButton():new( ::oStatPB, , {712,4}, {76,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 }, { XBP_PP_COMPOUNDNAME, "8.Arial" } } )
   ::oPB10:caption := "F10"
   ::oPB10:tabStop := .T.
   ::oPB10:activate := {|| NIL }

   ::oStatbar := XbpStatusBar():new( ::drawingArea, , {0,0}, {792,22}, { { XBP_PP_COMPOUNDNAME, "10.System Fett" } } )

*   ::Static1  := XbpStatic():new( ::oStatbar, , {771,0}, {92,16} )
*   ::Static1:visible := .F.

   ::oCBLeft   := XbpCombobox():new( ::drawingArea, , {12,478}, {50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oCBLeft:tabstop := .T.

   ::oCBright  := XbpCombobox():new( ::drawingArea, , {400,478}, {50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oCBright:tabstop := .T.

   ::oActivDir := XbpStatic():new( ::drawingArea, , {12,72}, {380,20} )
   ::oActivDir:caption := "Text"
   ::oActivDir:clipSiblings := .T.
   ::oActivDir:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT

   ::oPBHis    := XbpPushButton():new( ::drawingArea, , {760,72}, {16,20}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oPBHis:caption := ""
   ::oPBHis:tabStop := .T.
   ::oPBHis:activate := {|| NIL }

   ::oRunShell := XbpSLE():new( ::drawingArea, , {400,72}, {360,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::oRunShell:bufferLength := 250
   ::oRunShell:tabStop := .T.


RETURN self


******************************************************************************
* Systemresourcen anfordern
******************************************************************************
METHOD XCMForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
LOCAL oBrowse1
LOCAL oBrowse2

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::ToolBar1:create()

   ::oSplit:create()

   ::oStatLWl:create()
   ::oStatLWl:DropZone := .T.

   ::oStatLWr:create()
   ::oStatLWr:DropZone := .T.

   ::oSplit:Predecessor  := ::oStatLWl
   ::oSplit:Successor    := ::oStatLWr

   ::oStatPB:create()
   ::oPB01:create()
   ::oPB02:create()
   ::oPB03:create()
   ::oPB04:create()
   ::oPB05:create()
   ::oPB06:create()
   ::oPB07:create()
   ::oPB08:create()
   ::oPB09:create()
   ::oPB10:create()

   ::oStatbar:create()

*   ::Static1:create()

*   oBrowse1 := XCMBrowse:New(::oStatLWl,1)
*   oBrowse2 := XCMBrowse:New(::oStatLWr,2)
*   ::oLW1 := XCMBrowse:New(::oStatLWl,1)
*   ::oLW2 := XCMBrowse:New(::oStatLWr,2)

   ::oPanel := ::oStatbar:getItem( 1 )
   ::oPanel:caption  := "Ready"
   ::oPanel:autosize := XBPSTATUSBAR_AUTOSIZE_SPRING

   ::oPanel := ::oStatbar:addItem()
   ::oPanel:Style := XBPSTATUSBAR_PANEL_TIME
   ::oPanel:autosize := XBPSTATUSBAR_AUTOSIZE_CONTENTS

   ::ToolBar1 :imageWidth  := 16
   ::ToolBar1 :imageHeight := 16
   ::ToolBar1 :addItem("open", 2003)
   ::ToolBar1 :addItem("next", 2005)
   ::ToolBar1 :transparentColor := GRA_CLR_INVALID

   ::oCBLeft:create()

   ::oCBright:create()

   ::oActivDir:create()

   ::oPBHis:create()

   ::oRunShell:create()
   ::oRunShell:DropZone := .T.

*   _Resize( ::XbpDialog , ::oSplit, ::oStatLWl , ::oStatLWr , ::oLW1 , ::oLW2 )

RETURN self

******************************************************************************
* Change the sorting order of the data source
* The 'index' array is sorted according to values of the data source array
******************************************************************************

******************************************************************************
* Return full path name
******************************************************************************
FUNCTION FullPath()
LOCAL cPath := CurDrive() + ":\"

   IF !Empty( CurDir() )
      cPath := cPath + CurDir() + "\"
   ENDIF

RETURN cPath

******************************************************************************
* Change the sorting order of the data source
* The 'index' array is sorted according to values of the data source array
******************************************************************************
FUNCTION SortFiles( oBrowse, nSubScript )
   LOCAL aArray  := oBrowse:cargo
   LOCAL oColumn := oBrowse:getColumn( aArray[ ARR_ORD ] + 1 )
   LOCAL bBlock  := oColumn:colorBlock

DEFAULT nSubScript TO F_NAME

   ASort( aArray[ ARR_SORT ] ,,, ;
      {|i,j| aArray[ ARR_SRC, i, nSubScript ] < ;
             aArray[ ARR_SRC, j, nSubScript ] } )

   oColumn:colorBlock := NIL
   aArray[ ARR_ORD ]  := nSubScript
   oBrowse:getColumn( nSubScript + 1 ):colorBlock := bBlock

   oBrowse:goTop()
   oBrowse:refreshAll()

RETURN NIL

******************************************************************************
* Change directory and update data source array
* Note: The array reference in oBrowse:cargo must not be changed!
* Only arrays may be changed which are referenced in the array oBrowse:cargo!
* Otherwise all oXbpColumn:dataLink code blocks must be re-created, too
******************************************************************************
FUNCTION ChangeDirectory( oBrowse )
   LOCAL aArray  := oBrowse:cargo
   LOCAL i       := aArray[ ARR_SORT, aArray[ ARR_NO ] ]
   LOCAL aFile   := aArray[ ARR_SRC , i ]
   LOCAL cPath   := aArray[ ARR_PATH ]
   LOCAL lChange := ( "D" $ aFile[ F_ATTR ] )
   LOCAL cDir, nLen

   IF ! lChange
      RETURN NIL                       // Selected file is no directory
   ENDIF

   cDir  := aFile[ F_NAME ]
   cPath := SubStr( cPath, 1, Len(cPath) - 1 )

   IF cDir == "."                      // Current directory is selected
      lChange := .F.

   ELSEIF cDir == ".."                 // Parent directory is selected

      i := RAt( "\", cPath )
      IF i > 0
         cDir := SubStr( cPath, 1, i-1 )
         IF RAt( ":", cPath ) == 2
            cDir += "\"
         ENDIF
      ELSE
         lChange := .F.                // Root directory is current
      ENDIF

   ELSE
      cDir := cPath + "\" + cDir       // Child directory is selected
   ENDIF

   IF ! lChange
      RETURN NIL                       // Directory cannot be changed
   ENDIF

   CurDir( cDir )                      // Change current directory
   aArray[ ARR_PATH ] := FullPath()
   aArray[ ARR_SRC  ] := Directory( "*.*", "D" )
   nLen               := Len( aArray[ ARR_SRC ] )
   aArray[ ARR_SORT ] := AEval( Array(nLen), {|x,i| x:=i } ,,, .T. )
   SortFiles( oBrowse, aArray[ ARR_ORD ] )

RETURN NIL

FUNCTION SP_LW(xValue)
   IF PCOUNT() > 0
      oLW0 := xValue
   ENDIF
RETURN oLW0


STATIC FUNCTION MyDirec(nLen)
   LOCAL nStartAt := 1
   LOCAL aDir
   LOCAL aNeu := {}, x, y

   nStartAt := 1

   // Current Directory
   aDir := DIRECTORY("*.*", "HSD")
   nLen := LEN(aDir)

   FOR x = 1 to nLen
       AADD(aNeu,{"","","","","","","","","","",""})
       FOR y = 1 TO 10
           aNeu[x,y] := aDir[x,y]
       NEXT
       IF LEN(TRIM(aDir[x,1])) > 12
          aNeu[x,11] := GetShortFileName(aDir[x,1])
       ELSE
          aNeu[x,11] := aDir[x,1]
       ENDIF
   NEXT
   aDir := ACLONE(aNeu)
   aNeu := {}
   // make all FileNames LOWER()
   AEVAL(aDir, {|x| x.filename := LOWER(x.filename) })
   ASORT(aDir,,, {|x,y| x.filename < y.filename})

   // First, put all sub-directories
   // at the beginning of the list
   ASORT(aDir,,, {|x,y| "D" $ x.fileattrib })

   // Now, lets find out where the other
   // files are
   AEVAL(aDir, {|x,i| nStartAt := ;
               IF("D" $ x.fileattrib, i, nStartAt) })

   // Sort sub-directories only
   ASORT(aDir, 1, nStartAt, {|x,y| x.filename < y.filename})
*   ASORT( aDir, 1, nStartAt, {|x,y| CompareFile(x.filename,y.filename) } )
   nStartAt++

   // Sort only the non-directory files.
   // Sort Array based on the first subarray
   // element
*   ASORT(aDir, nStartAt,, {|x,y| x.filename < y.filename})
*   ASORT(aDir, nStartAt,, {|x,y| x.fileExt < y.fileExt})
*   ASORT(aDir, nStartAt,, {|x,y| Right( Upper( x[ F_NAME ] ), 3 ) < Right( Upper( y[ F_NAME ] ), 3 ) } )
**1**
   ASORT( aDir, nStartAt,, {|x,y| CompareFile(x.filename,y.filename) } )

   // Pad some subarray elements
   PadIt(@aDir, @nLen)
   // Return the array with directory information
   RETURN (aDir)

FUNCTION CompareFile( aX, aY )
LOCAL cName1, cName2

    /*
      Add code here to create cName1 and cName2 with
      the following structure:
      ext.name (instead of name.ext)
    */

cName1 := FINDEXT(aX)+FINDNAME(aX)
cName2 := FINDEXT(aY)+FINDNAME(aY)

RETURN ( cName1 < cName2 )

FUNCTION FINDNAME(filename)
LOCAL nPosi
LOCAL nRet

nPosi := AT(".",filename)
nRet  := SUBSTR(filename,1,nPosi-1,)

RETURN UPPER(nRet)


FUNCTION FINDEXT(filename)
LOCAL nPosi
LOCAL nRet

nPosi := AT(".",filename)
nRet  := SUBSTR(filename,nPosi+1,Len(filename))

RETURN UPPER(nRet)

Function GetShortFileName(cLongName)
LOCAL cShortName := space(255)
LOCAL nNameLen   := 1
   if empty(cLongName)
      return ('')
   else
      nNameLen := DllCall("Kernel32.DLL", DLL_STDCALL, "GetShortPathNameA", ;
                          cLongName, @cShortName, len(cShortName))
   endif
return (left(cShortName, nNameLen))

STATIC FUNCTION PadIt(aArray, nArrlen)
   LOCAL nPos, i, nALen, nNewALen
   LOCAL cTemp

   // Transverse array and its subarrays
   i := 1
   DO WHILE i <= LEN(aArray)
      IF ("D" $ aArray[i].fileattrib)
         IF (aArray[i].filename == ".")
            // Exclude current directory from list
            ADEL(aArray, i)
            // Shrink it!
            aArray := ASIZE(aArray, LEN(aArray) - 1)
            LOOP

         ELSEIF (aArray[i].filename == "..")
            aArray[i].filename := PADR(aArray[i].filename, 12)
            aArray[i].filesize := CHR(16) + "UP--DIR" +;
                                  CHR(17)

         ELSE
            aArray[i].filesize := CHR(16) + "SUB-DIR" +;
                                  CHR(17)
            nPos := AT(".",aArray[i].filename)
            IF nPos != 0
               aArray[i].filename := UPPER(;
                       PADR(SUBSTR(aArray[i].filename,;
                             1, nPos - 1), 9) +;
                       PADR(SUBSTR(aArray[i].filename,;
                             nPos + 1, 3), 3))
            ELSE
               aArray[i].filename := UPPER(PADR(aArray[i].filename, 12))

            ENDIF

         ENDIF

      ELSE
         // Pad name
         nPos := AT(".",aArray[i].filename)
         IF nPos != 0
            aArray[i].filename := ;
                    PADR(SUBSTR(aArray[i].filename,;
                          1, nPos - 1), 9) +;
                    PADR(SUBSTR(aArray[i].filename,;
                          nPos + 1, 3), 3)
         ELSE
            aArray[i].filename := PADR(aArray[i].filename, 12)

         ENDIF
         aArray[i].filename := LOWER(aArray[i].filename)
         // Pad size
         aArray[i].filesize := STR(aArray[i].filesize, 9)

      ENDIF
      // Pad time
      aArray[i].filetime := SUBSTR(aArray[i].filetime, 1, 5)
      // Add a for AM or p for PM
      cTemp := VAL(SUBSTR(aArray[i].filetime, 1, 2))
      aArray[i].filetime += IF(cTemp >= 12 .AND. cTemp <= 23,;
                             "p", "a")
      cTemp := IF(cTemp > 12, cTemp % 12, cTemp)
      cTemp := STR(cTemp, 2, 0)
      aArray[i].filetime := cTemp +;
                          SUBSTR(aArray[i].filetime, 3, 4)

      // Keep counter updated
      i++

   END
   nArrLen := LEN(aArray)
RETURN (NIL)

Static Function  _Resize( poDlg , poSplitBar , poBox1 , poBox2 , poMLE1 , poMLE2 )

#Define DEF_BUTTON_BAR_HEIGHT   94
#Define DEF_CONTROL_OFFSET       4
#Define DEF_OBENWEG            100

   poBox1:SetSize( { poBox1:CurrentSize()[1] + (DEF_CONTROL_OFFSET*2) , poDlg:DrawingArea:CurrentSize()[2] - DEF_BUTTON_BAR_HEIGHT - DEF_CONTROL_OFFSET -DEF_OBENWEG}  )
   poBox2:SetSize( { poDlg:DrawingArea:CurrentSize()[1] - poBox1:CurrentSize()[1] - poSplitBar:CurrentSize()[1] - (DEF_CONTROL_OFFSET*4)  ,  poDlg:DrawingArea:CurrentSize()[2] - DEF_BUTTON_BAR_HEIGHT - DEF_CONTROL_OFFSET -DEF_OBENWEG}  )

   poBox1:SetPos( { poBox1:CurrentPos()[1] ,  DEF_BUTTON_BAR_HEIGHT }  )
   poBox2:SetPos( { poBox1:CurrentSize()[1] + poSplitBar:CurrentSize()[1] + (DEF_CONTROL_OFFSET*3) ,  DEF_BUTTON_BAR_HEIGHT }  )

   poSplitBar:SetSize( { poSplitBar:CurrentSize()[1] + (DEF_CONTROL_OFFSET*2), poDlg:DrawingArea:CurrentSize()[2] - DEF_BUTTON_BAR_HEIGHT - DEF_CONTROL_OFFSET -DEF_OBENWEG}  )
   poSplitBar:SetPos( { poBox1:CurrentSize()[1] + DEF_CONTROL_OFFSET , 25 }  )

   //poSplitBar:SetSize( { poDlg:CurrentSize()[1] , poDlg:DrawingArea:CurrentSize()[2] }  )
   //poSplitBar:SetPos( { DEF_CONTROL_OFFSET ,  DEF_CONTROL_OFFSET  }  )
ALTD()

   poMle1:browser:SetSize( { poBox1:CurrentSize()[1] - (DEF_CONTROL_OFFSET*2) , poBox1:CurrentSize()[2] - (DEF_CONTROL_OFFSET*2) }  )
   poMle2:browser:SetSize( { poBox2:CurrentSize()[1] - (DEF_CONTROL_OFFSET*2) , poBox2:CurrentSize()[2] - (DEF_CONTROL_OFFSET*2) }  )

   poMle1:browser:SetPos( { DEF_CONTROL_OFFSET ,  DEF_CONTROL_OFFSET }  )
   poMle2:browser:SetPos( { DEF_CONTROL_OFFSET ,  DEF_CONTROL_OFFSET }  )

   //poSplitBar:SetSize( { 150  ,  poDlg:DrawingArea:CurrentSize()[2] - DEF_BUTTON_BAR_HEIGHT - DEF_CONTROL_OFFSET }  ) //poDlg:DrawingArea:CurrentSize()[1]

Return Nil


//EOF
/////