#define        GO_AHEAD            1
#define        ERASE_OK            0
#define        RENAME_OK           0

#xcommand      STABILIZE <x> =>    DISPBEGIN();;
                                   WHILE !(<x>:stabilize());;
                                   END;;
                                   DISPEND()

#xtranslate    .filename     =>    \[1\]
#xtranslate    .filesize     =>    \[2\]
#xtranslate    .filedate     =>    \[3\]
#xtranslate    .filetime     =>    \[4\]
#xtranslate    .fileattrib   =>    \[5\]
#xtranslate    .fileShort    =>    \[11\]

#xtranslate    .boxTitle     =>    \[1\]
#xtranslate    .boxMessage   =>    \[2\]
#xtranslate    .boxFileName  =>    \[3\]
#xtranslate    .boxFirstOpt  =>    \[4\]
#xtranslate    .boxSecondOpt =>    \[5\]

//********************************************************************
//
// FolderBrowse TreeView
//
//********************************************************************
// drive descriptor array
#define DRV_NAME        1
#define DRV_ICON        2

// if you put DriveSelect() in a DLL, the icons will presumably
// also be in that dll.  The function needs to know the name of
// the dll where the icons are stored.  Change his to the name of
// the DLL (in quotes: 'tools.dll').  If the icons are linked
// to the executable, then leave this as NIL.
#define DRV_ICON_DLL    NIL

// FolderBrowser icons
#define ICON_BASE     2099
#define ICON_FDRIVE   2101            // Floppy/stiffy drive
#define ICON_HDRIVE   2102            // Hard drive
#define ICON_NDRIVE   2103            // network drive
#define ICON_CDROM    2104            // cd-rom drive
#define ICON_CFOLDER  2105            // closed folder
#define ICON_OFOLDER  2106            // opened folder

// NOTE: the CDROM icon is used as the icon for the window.
//       If you put this code in a DLL, you'll need to make the
//       icon available in the exe too, using the same ID.
//       Alternatively, change the ::icon in the ::create() method.

// Drive Descriptors
#define DRIVE_UNKNOWN   0
#define DRIVE_NO_ROOT   1
#define DRIVE_REMOVABLE 2
#define DRIVE_FIXED     3
#define DRIVE_REMOTE    4
#define DRIVE_CDROM     5
#define DRIVE_RAMDISK   6

// default settings for directory delete options
#define FB_ALLOW_DEL_DIR         .T.    // enable "Delete" on context menu
                                        // when .F., next two options not relevant
#define FB_ALLOW_DEL_NOT_EMPTY   .T.    // allow "Delete" when directory not empty
#define FB_ALLOW_DEL_DIR_TREE    .F.    // perform sub-dir deletion
#define FB_ALLOW_DIR_CREATE_TREE .t.    // can create sub-dir tree

#define  PRES_PARAM { ;       // Presentation parameters for the browser
   {XBP_PP_COL_DA_COMPOUNDNAME   , FONT_DEFPROP_SMALL           }, ;
   {XBP_PP_COL_HA_HEIGHT         , 10                           }, ;
   {XBP_PP_COL_HA_CAPTION        , ""                           }, ;
   {XBP_PP_COL_DA_ROWHEIGHT      , 10                           }}

/*

   {XBP_PP_COL_HA_FGCLR          , XBPSYSCLR_WINDOWSTATICTEXT   }, ;
   {XBP_PP_COL_HA_BGCLR          , XBPSYSCLR_DIALOGBACKGROUND   }, ;
   {XBP_PP_COL_HA_HEIGHT         , 10                           }, ;
   {XBP_PP_COL_DA_FGCLR          , XBPSYSCLR_WINDOWSTATICTEXT   }, ;
   {XBP_PP_COL_DA_BGCLR          , XBPSYSCLR_WINDOW             }, ;
   {XBP_PP_COL_DA_HILITE_FGCLR   , XBPSYSCLR_HILITEFOREGROUND   }, ;
   {XBP_PP_COL_DA_HILITE_BGCLR   , XBPSYSCLR_HILITEBACKGROUND   }, ;
   {XBP_PP_COL_DA_COMPOUNDNAME   , FONT_DEFPROP_SMALL           }, ;
   {XBP_PP_COL_DA_ROWHEIGHT      , 10                           }, ;
   {XBP_PP_COL_DA_CELLFRAMELAYOUT, XBPFRAME_DOTTED+XBPFRAME_BOX }, ;
   {XBP_PP_COL_DA_FRAMELAYOUT    , XBPFRAME_NONE+XBPFRAME_BOX   }, ;
   {XBP_PP_COL_DA_ROWSEPARATOR   , XBPCOL_SEP_LINE+XBPCOL_SEP_DOTTED }, ;
   {XBP_PP_COL_DA_COLSEPARATOR   , XBPCOL_SEP_LINE+XBPCOL_SEP_DOTTED }, ;
   {XBP_PP_COL_FA_FGCLR          , XBPSYSCLR_WINDOWSTATICTEXT   }, ;
   {XBP_PP_COL_FA_BGCLR          , XBPSYSCLR_3DFACE             }  }

*/

// structure of the array for oBrowse:cargo
#define  ARR_SRC   1              // Directory() array (Data source)
#define  ARR_NO    2              // 'record pointer' for array
#define  ARR_SORT  3              // 'Index' for array
#define  ARR_ORD   4              // Column number for ASort()
#define  ARR_PATH  5              // Current directory

#define  ARR_COUNT 5              // Full qualified name of current directory
